#define _TP_SIGN 0
#define _TP_NUMBER 1

#define _SIGN_PLUS 0
#define _SIGN_MINUS 1
#define _SIGN_MUL 2
#define _SIGN_DIV 3
#define _SIGN_O_BRACKET 4
#define _SIGN_C_BRACKET 5

typedef struct {
	int type, num;
} _OUT_BUF;

class b_calc:public stack {
private:
	stack *s_stack,*s_out,*s_calc;
	inline int getSignPriority(int sign);
public:
	b_calc();
	~b_calc();
	virtual int getNextEntity(int *num,int *type)=0; //abstract functions
	void dumpEntity(int num,int type);
	void dumpStack();	
	void dump();	
	void convert();
	void reset();
	float calc();
};
